﻿using System;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.JavaScript;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using System.ComponentModel.DataAnnotations;
using System.Collections;
using Syncfusion.JavaScript.DataSources;
using System.Runtime.Serialization;
using Syncfusion.JavaScript.Shared.Serializer;

namespace WebApplication8.Controllers
{
    public class HomeController : Controller
    {
        public static List<Orders> order = new List<Orders>();

        List<Employees> emp = new List<Employees>();
        public void BindDataSource()
        {
            int code = 10000;
            for (int i = 1; i < 10; i++)
            {
                order.Add(new Orders(code + 1, "ALFKI", i + 0, 2.3 * i, new DateTime(1991, 05, 15), "Berlin", weekdays.Monday));
                order.Add(new Orders(code + 2, "ANATR", i + 2, 3.3 * i, new DateTime(1990, 04, 04), "Madrid",weekdays.Thursday));
                order.Add(new Orders(code + 3, "ANTON", i + 1, 4.3 * i, new DateTime(1957, 11, 30), "Cholchester",weekdays.Tuesday));
                order.Add(new Orders(code + 4, "BLONP", i + 3, 5.3 * i, new DateTime(1930, 10, 22), "Marseille",weekdays.Friday));
                order.Add(new Orders(code + 5, "BOLID", i + 4, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen",weekdays.Sunday));
                code += 5;
            }
            emp.Add(new Employees(1, "Nancy", "Davolio", new DateTime(1948, 12, 08), "USA"));
            emp.Add(new Employees(2, "Andrew", "Fuller", new DateTime(1952, 02, 19), "USA"));
            emp.Add(new Employees(3, "Janet", "Leverling", new DateTime(1963, 08, 30), "USA"));
            emp.Add(new Employees(4, "Margaret", "Peacock", new DateTime(1937, 09, 19), "USA"));
            emp.Add(new Employees(5, "Steven", "Buchanan", new DateTime(1955, 03, 04), "UK"));
            emp.Add(new Employees(6, "Michael", "Suyama", new DateTime(1963, 07, 02), "UK"));
            emp.Add(new Employees(7, "Robert", "King", new DateTime(1960, 05, 29), "UK"));
            emp.Add(new Employees(8, "Laura", "Callahan", new DateTime(1958, 01, 09), "USA"));
            emp.Add(new Employees(9, "Laura", "Callahan", new DateTime(1958, 01, 09), "Australia"));
        }

        
        public class Orders
        {
            public Orders()
            {

            }
            public Orders(long OrderId, string CustomerId, int EmployeeId, double Freight, DateTime OrderDate, string ShipCity,weekdays val)
            {
                this.OrderID = OrderId;
                this.CustomerID = CustomerId;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.OrderDate = OrderDate;
                this.ShipCity = ShipCity;
                this.val = val;
               
            }
  
            [Range(0, int.MaxValue, ErrorMessage = "OrderID must be greater than 0.")]
            public long OrderID { get; set; }
            [StringLength(5, ErrorMessage = "CustomerID must be 5 characters.")]
            public string CustomerID { get; set; }
            [Range(1, 9, ErrorMessage = "EmployeeID must be between 0 and 9.")]
            public int EmployeeID { get; set; }
            [Display(Name = "Freight column")]
            public double Freight { get; set; }
            public DateTime OrderDate { get; set; }
            public string ShipCity { get; set; }
            [Newtonsoft.Json.JsonConverter(typeof(Newtonsoft.Json.Converters.StringEnumConverter))]
            public weekdays val { get; set; }
        }
        public class Employees
        {
            public Employees()
            {

            }
            public Employees(int EmployeeId, string FirstName, string LastName, DateTime BirthDate, string Country)
            {

                this.EmployeeID = EmployeeId;
                this.FirstName = FirstName;
                this.LastName = LastName;
                this.BirthDate = BirthDate;
                this.Country = Country;
            }
            public int EmployeeID { get; set; }
            public string FirstName { get; set; }
            public string LastName { get; set; }
            public DateTime BirthDate { get; set; }
            public string Country { get; set; }
        }
        public IActionResult Index()
        {
            DataManagerConverter.Serializer = new DMSerial();
            BindDataSource();
            ViewBag.dataSource = order;
            return View();
        }

        public enum weekdays {
            [Display(Name ="Monday")]
            Monday,
            [Display(Name = "Tuesday")]
            Tuesday,
            [Display(Name = "Wednesday")]
            Wednesday,
            [Display(Name = "Thursday")]
            Thursday,
            [Display(Name = "Friday")]
            Friday,
            [Display(Name = "Saturday")]
            Saturday,
            [Display(Name = "Sunday")]
            Sunday,
        }
        public class DMSerial : IDataSourceSerializer
        {
            public string Serialize(object obj)
            {
                var str = Newtonsoft.Json.JsonConvert.SerializeObject(obj);
                return str;
            }
        }
        
        public IActionResult About()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";

            return View();
        }

        public IActionResult Error()
        {
            return View();
        }
    }
}
